#include "uebung05.h"
#include <uebung05.moc>
#include <QMouseEvent>
#include <QKeyEvent>

typedef Vec<4,float> Vec4f;
typedef Vec<3,float> Vec3f;

Uebung05::Uebung05(QWidget *parent)
  : QGLWidget(parent)
{}

Uebung05::~Uebung05()
{}


void Uebung05::initializeGL()
{
	// Set up the rendering context, define display lists etc.:
	glDisable(GL_DEPTH_TEST); // We will draw planar
	glClearColor(0.53, 0.81, 0.92, 0.0);  // Sky-Blue
	glShadeModel(GL_SMOOTH);                      // Enables Smooth Shading
	glEnable (GL_BLEND);
	glEnable(GL_POLYGON_SMOOTH);
	glEnable(GL_MULTISAMPLE);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);            // Really Nice Perspective Calculations
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
	glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
	glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);
	glEnable(GL_POLYGON_SMOOTH);
// 	glDisable(GL_CULL_FACE);
	glCullFace (GL_BACK);
	glEnable(GL_CULL_FACE);
	mFieldDisplayList = glGenLists(1);
	glNewList(mFieldDisplayList, GL_COMPILE);
	static const Vec3f ground[] = {	Vec3f(-2048.0f,-2048.0f, 0.0f),
									Vec3f( 2048.0f,-2048.0f, 0.0f),
									Vec3f( 2048.0f, 2048.0f, 0.0f),
									Vec3f(-2048.0f, 2048.0f, 0.0f) };
	std::vector<Vec4f> const groundcolour(sizeof(ground)/sizeof(ground[0]), Vec4f(0.55f, 0.27f, 0.07f, 0.0f));
	static const Vec3f field[] = {	Vec3f(-3.f,-2.f, 0),
									Vec3f( 3.f,-2.f, 0),
									Vec3f( 3.f, 2.f, 0),
									Vec3f(-3.f, 2.f, 0) };
	std::vector<Vec4f> const fieldcolour(sizeof(ground)/sizeof(field[0]), Vec4f(0.f, 0.75f, 0.f, 0.f ));

	static const float fieldlength = 0.95f*6.f;
	static const float fieldwidth = 0.95f*4.f;
	static const float linewidth = 0.05f;
	static const float goalareadepth = 0.6f;
	static const float goalareawidth = 2.6f;
	static const float circleradius = 0.6f;
	static const float hfw = 0.5f*fieldwidth;
	static const float hfl = 0.5f*fieldlength;
	static const float hgw = 0.5f*goalareawidth;
	static const float penaltyDist = 1.8f;

	static const Vec3f fieldlines[] = {	Vec3f(-hfl, hfw-linewidth, 0),
										Vec3f( hfl, hfw-linewidth, 0), 
										Vec3f( hfl, hfw, 0), 
										Vec3f(-hfl, hfw, 0), 

										Vec3f(-hfl,-hfw, 0), 
										Vec3f( hfl,-hfw, 0), 
										Vec3f( hfl,-hfw+linewidth, 0), 
										Vec3f(-hfl,-hfw+linewidth, 0), 

										Vec3f( hfl-linewidth, -hfw, 0),
										Vec3f( hfl, -hfw, 0),
										Vec3f( hfl,  hfw, 0),
										Vec3f( hfl-linewidth,  hfw, 0),

										Vec3f(-hfl+linewidth, hfw, 0),
										Vec3f(-hfl, hfw, 0),
										Vec3f(-hfl,-hfw, 0),
										Vec3f(-hfl+linewidth,-hfw, 0),
// 										Penalty Marks

										Vec3f(-hfl+penaltyDist-linewidth,-0.5f*linewidth, 0),
										Vec3f(-hfl+penaltyDist+linewidth,-0.5f*linewidth, 0),
										Vec3f(-hfl+penaltyDist+linewidth, 0.5f*linewidth, 0),
										Vec3f(-hfl+penaltyDist-linewidth, 0.5f*linewidth, 0),
										Vec3f(-hfl+penaltyDist-0.5f*linewidth,-linewidth, 0),
										Vec3f(-hfl+penaltyDist+0.5f*linewidth,-linewidth, 0),
										Vec3f(-hfl+penaltyDist+0.5f*linewidth, linewidth, 0),
										Vec3f(-hfl+penaltyDist-0.5f*linewidth, linewidth, 0),

										Vec3f( hfl-penaltyDist-linewidth,-0.5f*linewidth, 0),
										Vec3f( hfl-penaltyDist+linewidth,-0.5f*linewidth, 0),
										Vec3f( hfl-penaltyDist+linewidth, 0.5f*linewidth, 0),
										Vec3f( hfl-penaltyDist-linewidth, 0.5f*linewidth, 0),
										Vec3f( hfl-penaltyDist-0.5f*linewidth,-linewidth, 0),
										Vec3f( hfl-penaltyDist+0.5f*linewidth,-linewidth, 0),
										Vec3f( hfl-penaltyDist+0.5f*linewidth, linewidth, 0),
										Vec3f( hfl-penaltyDist-0.5f*linewidth, linewidth, 0),

// 										Goal areas

// 										First
										Vec3f( hfl, hgw, 0),
										Vec3f( hfl-goalareadepth, hgw, 0), 
										Vec3f( hfl-goalareadepth, hgw-linewidth, 0), 
										Vec3f( hfl, hgw-linewidth, 0), 

										Vec3f( hfl,-hgw+linewidth, 0),
										Vec3f( hfl-goalareadepth,-hgw+linewidth, 0), 
										Vec3f( hfl-goalareadepth,-hgw, 0), 
										Vec3f( hfl,-hgw, 0), 

										Vec3f( hfl-goalareadepth-linewidth, -hgw, 0),
										Vec3f( hfl-goalareadepth, -hgw, 0),
										Vec3f( hfl-goalareadepth,  hgw, 0),
										Vec3f( hfl-goalareadepth-linewidth,  hgw, 0),

// 										Second 
										Vec3f(-hfl, hgw-linewidth, 0),
										Vec3f(-hfl+goalareadepth, hgw-linewidth, 0), 
										Vec3f(-hfl+goalareadepth, hgw, 0), 
										Vec3f(-hfl, hgw, 0), 

										Vec3f(-hfl,-hgw, 0),
										Vec3f(-hfl+goalareadepth,-hgw, 0), 
										Vec3f(-hfl+goalareadepth,-hgw+linewidth, 0), 
										Vec3f(-hfl,-hgw+linewidth, 0), 

										Vec3f(-hfl+goalareadepth+linewidth,  hgw, 0),
										Vec3f(-hfl+goalareadepth,  hgw, 0),
										Vec3f(-hfl+goalareadepth, -hgw, 0),
										Vec3f(-hfl+goalareadepth+linewidth, -hgw, 0),

// 										Middle line
										Vec3f(-0.5f*linewidth, -hfw, 0),
									    Vec3f( 0.5f*linewidth, -hfw, 0),
									    Vec3f( 0.5f*linewidth,  hfw, 0),
										Vec3f(-0.5f*linewidth,  hfw, 0)

					};

	std::vector<Vec4f> fieldlinecolours(sizeof(fieldlines)/sizeof(fieldlines[0]), Vec4f(1.f, 1.f, 1.f, 0.f));
	glEnable(GL_VERTEX_ARRAY);
	glEnable(GL_COLOR_ARRAY);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);

	glVertexPointer(3, GL_FLOAT, 0, &ground[0]);
	glColorPointer(4, GL_FLOAT, 0, &groundcolour[0]);
	glDrawArrays(GL_QUADS, 0, 4);

	glVertexPointer(3, GL_FLOAT, 0, &field[0]);
	glColorPointer(4, GL_FLOAT, 0, &fieldcolour[0]);
	glDrawArrays(GL_QUADS, 0, 4);

	glVertexPointer(3, GL_FLOAT, 0, &fieldlines[0]);
	glColorPointer(4, GL_FLOAT, 0, &fieldlinecolours.front());
	glDrawArrays(GL_QUADS, 0, sizeof(fieldlines)/(sizeof(float[3])));

	glColor3f(1.0f, 1.0f, 1.0f);
	GLUquadric * quadric =  gluNewQuadric();
	gluDisk(quadric, circleradius-linewidth, circleradius, 256, 1);
	gluDeleteQuadric(quadric);
	glEndList();
}

void Uebung05::mouseMoveEvent(QMouseEvent * event)
{
}


void Uebung05::keyPressEvent(QKeyEvent* event)
{
	if (event->key() == Qt::Key_S
		|| event->modifiers() & Qt::ControlModifier) {
			QImage image = grabFrameBuffer();
			image.save("snapshot.png");
	}
}


void Uebung05::resizeGL(int w, int h)
{
	// setup viewport, projection etc.:
	glViewport(0, 0, (GLint)w, (GLint)h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity(); 
	static const float fovy = 45.0f;
	static const float near = 0.1f;
	static const float far = 100.f;
	const float aspectratio = float(w)/float(std::max(1,h));
	gluPerspective(fovy, aspectratio, near, far);
	glMatrixMode(GL_MODELVIEW);   // Select The Modelview Matrix
	glLoadIdentity();             // Reset The Modelview Matrix
}

void Uebung05::paintGL()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glCallList(mFieldDisplayList);
// 	gluLookAt(-1.5, 0.4, 0.3, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0);
	gluLookAt(0.0, 0.0, 6.00, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
}
